#ifndef Controller_h
#define Controller_h

#include "Arduino.h"

// I/O Pins used by controller - 4 Required
#define CONTROLLER_BUTTON_PIN_A 3
#define CONTROLLER_BUTTON_PIN_B 4
#define CONTROLLER_BUTTON_PIN_C 5

#define CONTROLLER_BUTTON_PIN_READ 7

// Bit values for each button
// Label them however you have them physically labeled on the controller
#define CONTROLLER_BUTTON_UP 1
#define CONTROLLER_BUTTON_LEFT 2
#define CONTROLLER_BUTTON_RIGHT 4
#define CONTROLLER_BUTTON_DOWN 8

#define CONTROLLER_BUTTON_A 16
#define CONTROLLER_BUTTON_C 32
#define CONTROLLER_BUTTON_B 64
#define CONTROLLER_BUTTON_D 128

class Controller {
  private:
    static byte buttons;
    static byte unreleased;

  public:

    static void Init();

    static void ReadButtons();

    static bool IsPressed(int button);
    static bool IsPressedAgain(int button);
    static void MarkUnreleased(int button);

    static int GetButtons();
    static int GetUnreleased();
};


#endif
