#ifndef DinoController_h
#define DinoController_h

#define DINO_STATE_WALK1_TRANSITION 1
#define DINO_STATE_WALK1 2

#define DINO_STATE_WALK2_TRANSITION 3
#define DINO_STATE_WALK2 4

#define DINO_STATE_JUMP 5
#define DINO_STATE_CROUCH 6

#include "Arduino.h"
#include "LiquidCrystal_I2C.h"

class DinoController {
  private:
    static byte dinoHitL[8] = {
      0b00000,
      0b00000,
      0b00111,
      0b00111,
      0b00111,
      0b00101,
      0b00111,
      0b00011
    };

    static byte dinoHitR[8] = {
      0b00000,
      0b00000,
      0b01000,
      0b01000,
      0b01000,
      0b01000,
      0b11000,
      0b10000
    };

    static byte dinoTL1[8] = {
      0b00000,
      0b00000,
      0b00000,
      0b00000,
      0b00000,
      0b00000,
      0b00001,
      0b00011
    };

    static byte dinoTR1[8] = {
      0b00000,
      0b00000,
      0b00000,
      0b11111,
      0b10111,
      0b11111,
      0b10000,
      0b11111
    };

    static byte dinoBL1[8] = {
      0b00011,
      0b10011,
      0b11011,
      0b11111,
      0b11111,
      0b01110,
      0b00110,
      0b00000
    };

    static byte dinoBR1[8] = {
      0b10000,
      0b11100,
      0b10100,
      0b10000,
      0b11000,
      0b11000,
      0b11000,
      0b00000
    };

    static byte dinoBL2[8] = {
      0b10011,
      0b11011,
      0b11011,
      0b11111,
      0b01111,
      0b00111,
      0b00011,
      0b00000
    };

    static byte dinoBR2[8] = {
      0b10000,
      0b11000,
      0b10100,
      0b10100,
      0b10000,
      0b10000,
      0b10000,
      0b00000
    };

    static byte JumpCrouch1[8] = {
      0b00000,
      0b00000,
      0b00011,
      0b00111,
      0b01111,
      0b11111,
      0b00011,
      0b00011
    };

    static byte JumpCrouch2[8] = {
      0b00000,
      0b00000,
      0b11000,
      0b11110,
      0b11111,
      0b11111,
      0b10100,
      0b10110
    };

    static byte JumpCrouch3[8] = {
      0b00000,
      0b00000,
      0b00000,
      0b11111,
      0b10111,
      0b11111,
      0b11000,
      0b11111
    };

    float dino_state_time;
    float dino_hit_timer;

    float dino_state_duration;

    void NextState();
    void SetWalk1();
    void SetWalk2();
    void SetJumpCrouch();

  public:

    byte dinoTL[8];
    byte dinoTR[8];
    byte dinoBL[8];
    byte dinoBR[8];
    bool dino_sprite_change;
    int dino_state;
    bool dino_is_hit;

    void Init();
    void Update(float s);
    void Jump();
    void Crouch();
    void Hit();

};

#endif
