#include "Arduino.h"
#include "WeedController.h"

// needs to be define here with the actual value in the h file
static byte WeedController::frame1[8];
static byte WeedController::frame2[8];
static byte WeedController::frame3[8];
static byte WeedController::frame4[8];

void WeedController::Init() {
  weed_state = WEED_STATE_WALK1_TRANSITION;
  weed_state_time = 0;
  weed_state_duration = 0;
  SetFrame(0);
}

void WeedController::Update(float s) {
  weed_state_time += s;
  if (weed_state_time >= weed_state_duration) {
    NextState();
  }
}

void WeedController::SetFrame(int num) {
  int j;
  switch (num) {
    case 0:
      for (j = 0; j < 8; j++) {
        frame[j] = frame1[j];
      }
      break;
    case 1:
      for (j = 0; j < 8; j++) {
        frame[j] = frame2[j];
      }
      break;
    case 2:
      for (j = 0; j < 8; j++) {
        frame[j] = frame3[j];
      }
      break;
    case 3:
      for (j = 0; j < 8; j++) {
        frame[j] = frame4[j];
      }
      break;
  }
  weed_sprite_change = true;
}

void WeedController::NextState() {
  switch (weed_state) {
    case WEED_STATE_WALK1_TRANSITION:
      SetFrame(0);
      weed_state = WEED_STATE_WALK1;
      weed_state_duration = 0.250;
      break;
    case WEED_STATE_WALK1:
      weed_state = WEED_STATE_WALK2_TRANSITION;
      weed_state_duration = 0;
      break;
    case WEED_STATE_WALK2_TRANSITION:
      SetFrame(1);
      weed_state = WEED_STATE_WALK2;
      weed_state_duration = 0.250;
      break;
    case WEED_STATE_WALK2:
      weed_state = WEED_STATE_WALK3_TRANSITION;
      weed_state_duration = 0;
      break;
    case WEED_STATE_WALK3_TRANSITION:
      SetFrame(2);
      weed_state = WEED_STATE_WALK3;
      weed_state_duration = 0.250;
      break;
    case WEED_STATE_WALK3:
      weed_state = WEED_STATE_WALK4_TRANSITION;
      weed_state_duration = 0;
      break;
    case WEED_STATE_WALK4_TRANSITION:
      SetFrame(3);
      weed_state = WEED_STATE_WALK4;
      weed_state_duration = 0.250;
      break;
    case WEED_STATE_WALK4:
      weed_state = WEED_STATE_WALK1_TRANSITION;
      weed_state_duration = 0;
      break;
  }

  weed_state_time = 0;
}
