#ifndef WeedController_h
#define WeedController_h

#define WEED_STATE_WALK1_TRANSITION 1
#define WEED_STATE_WALK1 2

#define WEED_STATE_WALK2_TRANSITION 3
#define WEED_STATE_WALK2 4

#define WEED_STATE_WALK3_TRANSITION 5
#define WEED_STATE_WALK3 6

#define WEED_STATE_WALK4_TRANSITION 7
#define WEED_STATE_WALK4 8

#include "Arduino.h"
#include "LiquidCrystal_I2C.h"

class WeedController {
  private:
    static byte frame1[8] = {
      0b00000,
      0b00000,
      0b00110,
      0b01101,
      0b10111,
      0b11011,
      0b01110,
      0b01100
    };

    static byte frame2[8] = {
      0b00000,
      0b00000,
      0b00000,
      0b00000,
      0b10110,
      0b11101,
      0b11011,
      0b00110
    };

    static byte frame3[8] = {
      0b00000,
      0b00000,
      0b00000,
      0b01010,
      0b11100,
      0b10111,
      0b01111,
      0b00110
    };

    static byte frame4[8] = {
      0b00000,
      0b00000,
      0b11100,
      0b10110,
      0b01111,
      0b11011,
      0b01110,
      0b00000
    };


    int weed_state;
    float weed_state_time;
    float weed_state_duration;

    void NextState();
    void SetFrame(int num);

  public:

    byte frame[8];
    bool weed_sprite_change;


    void Init();
    void Update(float s);

};

#endif

